diff -urN a/usr/share/perl5/PVE/Storage/ZFSPoolPlugin.pm b/usr/share/perl5/PVE/Storage/ZFSPoolPlugin.pm
--- a/usr/share/perl5/PVE/Storage/ZFSPoolPlugin.pm	2022-03-25 10:56:05.000000000 +0800
+++ b/usr/share/perl5/PVE/Storage/ZFSPoolPlugin.pm	2022-03-25 12:04:49.838361850 +0800
@@ -438,15 +438,26 @@
     my (undef, $vname, undef, undef, undef, undef, $format) =
         $class->parse_volname($volname);
 
-    my $attr = $format eq 'subvol' ? 'refquota' : 'volsize';
-    my $value = $class->zfs_get_properties($scfg, $attr, "$scfg->{pool}/$vname");
-    if ($value =~ /^(\d+)$/) {
-	return $1;
+    my $size = 0;
+    my $used = 0;
+
+    my $attr = $format eq 'subvol' ? 'refquota' : 'volsize,used,origin,name';
+
+    my @value = $class->zfs_get_properties($scfg, $attr, "$scfg->{pool}/$vname");
+
+    if ($value[0] =~ /^(\d+)$/) {
+        $size = $1;
     }
 
-    die "Could not get zfs volume size\n";
+    if ($value[0] =~ /^(\d+)$/) {
+        $used = $1;
+    }
+
+    return wantarray ? ($size, $format,$used, 0, undef) : $size;
+    #`die "Could not get zfs volume size\n";
 }
 
+
 sub volume_snapshot {
     my ($class, $scfg, $storeid, $volname, $snap) = @_;
 
